/* ########################################################################

				 decl.h

   File: decl.h
   Path: /home/fournigault/c/X11/xcoral-2.33/Smac/decl.h
   Description: 
   Created: Tue Feb 21 12:52:20 MET 1995
   Author: Bruno Pages
   Modified: Tue Feb 21 12:52:21 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */



#include <string.h>

/* Pour aider la construction des instructions */

#include "list.h"
#include "Instruction_.h"
  
extern int Is_Terminal;
extern int Has_Unterminal_Return;

extern FCT( Instruction *, make_integer,(List *, int) );
#define memo_integer(str)		\
	AddLast(Memo, List__List(make_integer, (void *) (Object) atoi(str)))

#define memo_negate_integer(str)		\
	AddLast(Memo, List__List(make_integer, (void *) (Object) -atoi(str)))

extern FCT( Instruction *, make_char,(List *, int) );
extern FCT( char, lire_char,(char *) );
#define memo_char(str)		\
	AddLast(Memo, List__List(make_char, (void *) (Object) lire_char(str)))

extern FCT( Instruction *, make_string,(List *, int) );
extern FCT( char *, lire_string,(char *)	);
#define memo_string(str)		\
	AddLast(Memo, List__List(make_string, lire_string(str)))
     
/**/

extern FCT( Instruction *, just_a_mark,(List *, int) );
extern FCT( void, memo_empty_block,() );
extern FCT( void, memo_block,() );
extern char * begin_block;

#define mark_begin_block()		\
  	AddLast(Memo, List__List(just_a_mark, begin_block))
/**/

extern FCT( Instruction *, make_binary_oper,(List *, int) );
#define memo_binary_oper(str)		\
        void ** m = (void **) Malloc(3 * sizeof(void *));	\
        m[0] = Strdup(str);		\
        PopLast(Memo, m[2]);		\
        PopLast(Memo, m[1]);		\
	AddLast(Memo, List__List(make_binary_oper, (char*) m))

		
extern FCT( Instruction *, make_identifier,(List *, int) );
#define memo_identifier(str)		\
	AddLast(Memo, List__List(make_identifier, Strdup(str)))

extern FCT( Instruction *, make_typedef,(List *, int) );
#define memo_typedef(type)		\
	AddLast(Memo, List__List(make_typedef, (char *) type))

/**/

extern FCT( Instruction *, make_oper_ampersand,(List *, int)	);
extern FCT( Instruction *, make_oper_asterisk,(List *, int)	);
extern FCT( Instruction *, make_oper_mono_plus,(List *, int)	);
extern FCT( Instruction *, make_oper_mono_minus,(List *, int)	);
extern FCT( Instruction *, make_oper_complement,(List *, int)	);
extern FCT( Instruction *, make_oper_not,(List *, int)	);

#define memo_unary_oper()		\
       PopLast(Memo, Memo->previous->info)

#define memo_oper_ampersand()	\
       AddLast(Memo, List__List(make_oper_ampersand, 0))
     
#define memo_oper_asterisk()	\
       AddLast(Memo, List__List(make_oper_asterisk, 0))
     
#define memo_oper_mono_plus()	\
       AddLast(Memo, List__List(make_oper_mono_plus, 0))
     
#define memo_oper_mono_minus()	\
       AddLast(Memo, List__List(make_oper_mono_minus, 0))
     
#define memo_oper_complement()	\
       AddLast(Memo, List__List(make_oper_complement, 0))
     
#define memo_oper_not()	\
       AddLast(Memo, List__List(make_oper_not, 0))

/**/

extern char * asterisk;
#define mark_asterisk()		\
	AddLast(Memo, List__List(just_a_mark, asterisk))

extern FCT( Instruction *, make_cast,(List *, int) );
#define memo_cast()		\
        void ** m = (void **) Malloc(2 * sizeof(void *));	\
        extern Type * the_abstract_type();		\
        PopLast(Memo, m[1]);		\
        m[0] = the_abstract_type();		\
	if (m[0] == 0) { free(m); YYABORT;}	\
	AddLast(Memo, List__List(make_cast, m))

/**/

extern FCT( Instruction *, make_arith_if,(List *, int) );
#define memo_arith_if()		\
       	List ** m = (List **) Malloc(3 * sizeof(List *));	\
        PopLast(Memo, m[2]);	\
        PopLast(Memo, m[1]);	\
        PopLast(Memo, m[0]);	\
	AddLast(Memo, List__List(make_arith_if, m))

/**/
     
extern FCT( Instruction *, make_array_access,(List *, int) );
#define memo_array_access()		\
       	List ** m = (List **) Malloc(2 * sizeof(void *));	\
        PopLast(Memo, m[1]);	\
        PopLast(Memo, m[0]);	\
	AddLast(Memo, List__List(make_array_access, m))

/**/
     
extern FCT( Instruction *, make_assignment,(List *, int) );
#define memo_assignment()		\
       	List ** m = (List **) Malloc(3 * sizeof(List *));	\
        PopLast(Memo, m[2]);	\
        PopLast(Memo, m[1]);	\
        PopLast(Memo, m[0]);	\
	AddLast(Memo, List__List(make_assignment, m))

/**/

extern FCT( Instruction *, make_control,(List *, int) );
#define memo_break()		\
	AddLast(Memo, List__List(make_control, 0))

#define memo_continue()		\
	AddLast(Memo, List__List(make_control, (char *) 1))

extern FCT( Instruction *, make_return,(List *, int) );
#define memo_return()		\
        List * l = List__List(Memo->fct, (void *) Memo->info);	\
        Memo->fct = make_return;	\
        Memo->info = (Object) l

/**/

extern FCT( Instruction *, make_case,(List *, int) );
#define memo_case()		\
        List * l = List__List(Memo->fct, (void *) Memo->info);	\
        Memo->fct = make_case;	\
        Memo->info = (Object) l

#define memo_default()		\
	AddLast(Memo, List__List(make_case, 0))

extern FCT( void, memo_switch,() );

extern FCT( Instruction *, make_if,(List *, int) );
#define memo_if()		\
        void ** m = (void **) Malloc(3 * sizeof(void *));	\
        m[2] = 0;	\
        PopLast(Memo, m[1]);		\
        PopLast(Memo, m[0]);		\
	AddLast(Memo, List__List(make_if, m))

#define memo_if_else()		\
        void ** m = (void **) Malloc(3 * sizeof(void *));	\
        PopLast(Memo, m[2]);		\
        PopLast(Memo, m[1]);		\
        PopLast(Memo, m[0]);		\
	AddLast(Memo, List__List(make_if, m))

extern FCT( Instruction *, make_do_while,(List *, int) );
#define memo_do_while()		\
        void ** m = (void **) Malloc(2 * sizeof(void *));	\
        PopLast(Memo, m[1]);		\
        PopLast(Memo, m[0]);		\
	AddLast(Memo, List__List(make_do_while, m))

extern FCT( Instruction *, make_while,(List *, int) );
#define memo_while()		\
        void ** m = (void **) Malloc(2 * sizeof(void *));	\
        PopLast(Memo, m[1]);		\
        PopLast(Memo, m[0]);		\
	AddLast(Memo, List__List(make_while, m))

extern FCT( Instruction *, make_for,(List *, int) );
#define memo_for()		\
        void ** m = (void **) Malloc(4 * sizeof(void *));	\
        PopLast(Memo, m[3]);		\
        PopLast(Memo, m[2]);		\
        PopLast(Memo, m[1]);		\
        PopLast(Memo, m[0]);		\
	AddLast(Memo, List__List(make_for, m))

/**/

extern FCT( void, memo_comma,() );
     
extern FCT( Instruction *, no_comma_expression,(List *, int) );
#define memo_no_comma_expression()		\
	AddLast(Memo, List__List(no_comma_expression, 0))


/**/

extern char * some_args;
#define mark_some_args()		\
	AddLast(Memo, List__List(just_a_mark, some_args))

extern char * first_arg;
#define mark_first_arg()		\
	AddLast(Memo, List__List(just_a_mark, first_arg))

extern char * one_arg;
#define mark_one_arg()		\
	AddLast(Memo, List__List(just_a_mark, one_arg))

extern FCT( Instruction *, make_funcall,(List *, int) );
     
#define memo_funcall_0_arg()		\
        char ** m = (char **) Malloc(2 * sizeof(void *));	\
        m[0] = (char *) 0;		\
        PopLast(Memo, m[1]);	\
	AddLast(Memo, List__List(make_funcall, (char*) m))

extern FCT( void, memo_funcall_nargs,() );

/**/

extern FCT( Instruction *, make_post_incrdecr,(List *, int) );
#define memo_post_decr()					\
        void ** m = (void **) Malloc(2 * sizeof(void *));	\
        m[0] = List__List(Memo->fct, (void *) Memo->info);	\
        m[1] = (char *) -1;				\
	Memo->fct = make_post_incrdecr;	\
        Memo->info = (Object) m

#define memo_post_incr()					\
        void ** m = (void **) Malloc(2 * sizeof(void *));	\
        m[0] = List__List(Memo->fct, (void *) Memo->info);	\
        m[1] = (char *) 1;				\
	Memo->fct = make_post_incrdecr;	\
        Memo->info = (Object) m

#define memo_pre_decr()		\
        void ** m = (void **) Malloc(3 * sizeof(void *));	\
        m[0] = List__List(Memo->fct, (void *) Memo->info);	\
        m[1] = List__List(make_identifier, Strdup("-="));	\
        m[2] = List__List(make_integer, (void *) 1);	\
	Memo->fct = make_assignment;	\
        Memo->info = (Object) m

#define memo_pre_incr()		\
        void ** m = (void **) Malloc(3 * sizeof(void *));	\
        m[0] = List__List(Memo->fct, (void *) Memo->info);	\
        m[1] = List__List(make_identifier, Strdup("+="));	\
        m[2] = List__List(make_integer, (void *) 1);	\
	Memo->fct = make_assignment;	\
        Memo->info = (Object) m

/**/

extern FCT( Instruction *, make_sizeof_type,(List *, int) );
#define memo_sizeof_type()		\
        extern Type * the_abstract_type();	\
        Type * type = the_abstract_type();	\
	if (type == 0) YYABORT;			\
	AddLast(Memo, List__List(make_sizeof_type, type))

/**/

extern char * no_initializer;
#define mark_no_initializer()		\
	AddLast(Memo, List__List(just_a_mark, no_initializer))

extern char * begin_initializer_list;
#define mark_begin_initializer_list()	\
  	AddLast(Memo, List__List(just_a_mark, begin_initializer_list))

extern FCT ( void, memo_initializer_list,()	);

/**/
     
extern char * begin_of_list;
#define mark_begin_of_list()		\
  	AddLast(Memo, List__List(just_a_mark, begin_of_list))

extern FCT( void, end_of_list, () );
extern FCT( void, forget_list, () );
extern FCT( void, forget_list_if_possible, () );


/**/

extern char * begin_function_parameter_type_list;
#define mark_begin_function_parameter_type_list()		\
  	AddLast(Memo, List__List(just_a_mark, begin_function_parameter_type_list))

extern FCT( void, end_function_parameter_type_list,() );
extern FCT( void, end_identifier_list,() );

extern char * begin_identifier_list;
#define mark_begin_identifier_list()		\
  	AddLast(Memo, List__List(just_a_mark, begin_identifier_list))

FCT( Instruction *, function_parameter_type_list,(List *, int)	);
#define memo_empty_function_parameter_type_list()	\
	AddLast(Memo, List__List(function_parameter_type_list, 0))

extern FCT(int, ignored_param, () );
extern FCT(int, typed_param, () );

extern char * ellipsis;
#define memo_ellipsis()		\
	AddLast(Memo, List__List((InstrFct) ellipsis, 0))

    
/**/

extern FCT( int, partial_declaration,() );
extern FCT( int, declaration,() );

/**/

extern FCT(Instruction *, array_dim,(List *, int)	);

#define memo_array_decl_dim()		\
  	List * l = List__List(Memo->fct, (void *) Memo->info);	\
  	Memo->fct = array_dim;	\
  	Memo->info = (Object) l

extern FCT( Instruction *, array_decl_without_dim,(char *, int) );
#define memo_array_decl_without_dim()		\
	AddLast(Memo, List__List(array_dim, 0))

extern FCT( void, array_abstract_declarator,() );

/**/

FCT( Instruction *, make_function_def,(List *, int)	);
#define memo_make_function_def()		\
	AddLast(Memo, List__List(make_function_def, 0))

FCT( Instruction *, make_typedef_function_def,(List *, int)	);
#define memo_make_typedef_function_def()		\
	AddLast(Memo, List__List(make_typedef_function_def, 0))

FCT( Instruction *, make_typedef_oldfunction_def_without_decllist,(List *, int)	);
#define memo_make_typedef_oldfunction_def_without_decllist()		\
  	AddLast(Memo, List__List(make_typedef_oldfunction_def_without_decllist, 0))

FCT( Instruction *, make_oldfunction_def_without_decllist,(List *, int)	);
#define memo_make_oldfunction_def_without_decllist()		\
  	AddLast(Memo, List__List(make_oldfunction_def_without_decllist, 0))

FCT( Instruction *, make_typedef_oldfunction_def,(List *, int)	);
#define memo_make_typedef_oldfunction_def()		\
  	AddLast(Memo, List__List(make_typedef_oldfunction_def, 0))

FCT( Instruction *, make_oldfunction_def,(List *, int)	);
#define memo_make_oldfunction_def()		\
  	AddLast(Memo, List__List(make_oldfunction_def, 0))
