/* ########################################################################

				 for.c

   File: for.c
   Path: /home/fournigault/c/X11/xcoral-2.33/Smac/for.c
   Description: 
   Created: Tue Feb 21 12:53:43 MET 1995
   Author: Bruno Pages
   Modified: Tue Feb 21 12:53:43 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */



#include "For_.h"
#include "list.h"
#include "control.h"
#include "comma.h"

#include "decl.h" /**/

/*
  fct = make_for
  info = [init, test, modif, body]
*/

Instruction * make_for(l, del)
    List * l;
    int del;
{
  List ** m = (List **) l->info;
  Instruction * result;
  
  if (del) {
    DELETE(m[0]);
    DELETE(m[1]);
    DELETE(m[2]);
    DELETE(m[3]);
    result = (Instruction *) 0;
  }
  else {
    int terminal = Is_Terminal;
    int prev_in_iter = in_iteration;
    int prev_in_switch = in_switch;
    Instruction * init;
    
    Is_Terminal = 0;
    if (m[0]->fct == no_comma_expression) {
      DELETE(m[0]);
      init = 0;
    }
    else
      init = MAKE(m[0]);
    
    if (init == ERROR) {
      DELETE(m[1]);
      DELETE(m[2]);
      DELETE(m[3]);
      result = ERROR;
    }
    else {
      Instruction * test;
      
      if (m[1]->fct == no_comma_expression) {
	DELETE(m[1]);
	test = 0;
      }
      else 
	test = MAKE(m[1]);
      
      if (test == ERROR) {
	DELETE(m[2]);
	DELETE(m[3]);
	result = ERROR;
      }
      else {
	Instruction * modif;
	
	if (m[2]->fct == no_comma_expression) {
	  DELETE(m[2]);
	  modif = 0;
	}
	else 
	  modif = MAKE(m[2]);
	
	in_iteration = 1;
	in_switch = 0;
	
	if (modif == ERROR) {
	  DELETE(m[3]);
	  result = ERROR;
	}
	else {
	  Instruction * body;
	  
	  if (m[3]->fct == no_comma_expression) {
	    DELETE(m[3]);
	    body = 0;
	  }
	  else
	    body = MAKE(m[3]);
	  
	  result = (body == ERROR)
	    ? ERROR
	    : (Instruction *) For__For(init, test, modif, body, in_iteration != 1);
	}
      }
    }
    
    in_iteration = prev_in_iter;
    in_switch = prev_in_switch;
    
    Is_Terminal = terminal;
  }

  free(l);
  free(m);

  return result;
}
