/* ########################################################################

			      global_dict.c

   File: global_dict.c
   Path: /home/fournigault/c/X11/xcoral-2.31/global_dict.c
   Description: 
   Created: Fri Jan 27 11:25:07 MET 1995
   Author: Bruno Pages
   Modified: Fri Jan 27 11:25:08 MET 1995
   Last maintained by: Bruno Pages

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Bruno Pages

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */


#if HAVE_STRING_H
#include <string.h>
#else
#include <strings.h>
#endif
#include <stdio.h>

#include <stdlib.h>

#include "result_types.h"
#include "file_dict.h"
#include "global_dict.h"
#include "browser_util.h"

/*------------------------------------------------------------------------------
//                         Le dictionnaire des globals
//------------------------------------------------------------------------------
*/

GlobalRec* global_dict[GLOBAL_DICT_SIZE];

int global_count = 0;


/*------------------------------------------------------------------------------
   create the global
   warning : its _name if part of the object, never free it separately !
*/
GlobalRec* create_global(global_name, staticp, parsed_file)
    char* global_name;
    int staticp;
    char * parsed_file;
{
  GlobalRec**  head;
  GlobalRec*   current_global;
  int        x_size;
  
  get_head_Rec(global_name, global_dict, GLOBAL_DICT_SIZE, head);
  iter_Rec(global_name, GlobalRec, head, current_global) {
    if (current_global->_impl_file &&
	((! strcmp(parsed_file, current_global->_impl_file->_name)) ||
	 ((! staticp) && (! current_global->_static))))
      return current_global;
  }
  x_size = sizeof(GlobalRec) + GLOBAL_PLENGTH + strlen(global_name)  + 1;
  current_global = (GlobalRec*) xmalloc(x_size);
  if (current_global != Null) {
    create_Rec(global_name, GlobalRec, head, current_global, GLOBAL_PREFIX, GLOBAL_PLENGTH);
    current_global->_impl_file = Null;
    current_global->_impl_line = 0;
    current_global->_static = 0;
    current_global->_hide = 0;
    global_count++;
  }

  return(current_global);
}


/*------------------------------------------------------------------------------
*/
GlobalRec* find_global(global_name)
  char* global_name;
{
  GlobalRec**  head;
  GlobalRec*   current_global;

  get_head_Rec(global_name, global_dict, GLOBAL_DICT_SIZE, head);
  assoc_Rec(global_name, GlobalRec, head, current_global);
  return(current_global);
}


/*------------------------------------------------------------------------------
   remove globals defined in file_name, all globals if file_name == 0
*/
void global_eraze_file(file_name)
    char * file_name;
{
  FileRec * current_file;
  GlobalRec ** pdict;
  
  if (file_name == 0)
    current_file = 0;
  else if ((current_file = find_file(file_name)) == 0)
    return;
  
  for (pdict = global_dict;
       pdict != &global_dict[GLOBAL_DICT_SIZE];
       pdict += 1) {
    GlobalRec ** p_global = pdict;
    GlobalRec * current_global;
    
    while ((current_global = *p_global) != Null) {
      if ((current_file == 0) || (current_global->_impl_file == current_file)) {
	/* remove it */
	*p_global = current_global->_next;
	global_count -= 1;
	free(current_global);	/* _name is part of it */
      }
      else
	/* keep it */
	p_global = &current_global->_next;
    }
  }
}  


/*------------------------------------------------------------------------------
*/

void global_eraze_marked_files()
{
  GlobalRec ** pdict;
  GlobalRec ** head;
  GlobalRec * cell;
  int n;

  remove_Rec(global_dict, pdict, cell->_impl_file->_name == &Mark, 
	     GLOBAL_DICT_SIZE, head, cell, n, global_count, free);
}
